/*
   PIR Motion sensor interface with 8051
   http://www.electronicwings.com
 */


#include <reg51.h>

sbit Motion_detection=P0^0;     /* Read PIR sensor's data on this pin */
sbit LED=P1^0;                  /* connect LED to the PORT0.0 pin */


void MSdelay(unsigned int val);

void main(void) 
{
	P1=0;						/* initially LED turned OFF*/
	MSdelay(3000);			    /* power-on warm up dela for PIR */
    while(1)
    {
        if(Motion_detection==1)	/* check for human motion */
            LED = 0;	 		/* LED turn OFF for no Human motion */
			else       
            LED = 1;     		/* LED turn ON if any Human motion is detected */
    }
}
void MSdelay(unsigned int val)
{
     unsigned int i,j;
        for(i=0;i<=val;i++)
            for(j=0;j<112;j++);      /*This count Provide delay of 1 ms for 8MHz Frequency */
 }